var gInfoButton;

var cbfDoneButton;
var cbfTocontactsButton;
var cbfSendButton;
var cbfAddcontactButton;
var cbfDeletecontactsButton;
var cbfFromcontactsButton;
var cbfGetscodeButton;
var cbfScodecheckButton;

var cbfHistviewButton;
var cbfHistdeleteButton;
var cbfHistclearButton;

var cbfBackButton;
var cbfReplyButton;

var cbfInboxviewButton;
var cbfInboxdeleteButton;
var cbfInboxclearButton;
var cbfInboxcheckButton;

var cbfClearmessageButton;
var cbfUpdatebalanceButton;
var cbfToinboxButton;

var cbfConfyesButton;
var cbfConfnoButton;

var balancemode = false;

var response;
var prefs;
var mainsend;
var prefmessage;
var contacts;

var confirmedaction;

var numselected = 0;

var lastmsgtime = 0;
var lasttime = 0;

var active = false;

var prefsmode = "preferences";
var oldprefsmode = "preferences";

var fadefrom;
var fadeto;

function cbfalertdone() {
    /* Do nothing */
}

function cbfalert(message) {
    widget.system('CBF_ALERT="' + message + '" open CardBoardFishAlert.app', cbfalertdone);
}

function debug(message) {
    var debug = document.getElementById("debug");
    var current;
    if (debug) {
        current = debug.innerHTML;
        debug.innerHTML = current + message + "<br />";
    }
}

function repeat(shortstring, n) {
    var longstring = "";
    var i;
    for (i = 0; i < n; i++) {
        longstring += shortstring;
    }
    return longstring;
}

function switchPreferences(newprefsmode) {
    if (prefsmode == newprefsmode) {
        return;
    }

    if (!active) {
        return;
    }
    active = false;
    
    oldprefsmode = prefsmode;
    prefsmode = newprefsmode;

    if (prefsmode === "preferences") {
        cbfDoneButton.setText("Save");
    } else if (prefsmode === "inbox") {
        buildInbox();
        cbfDoneButton.setText("Back");
    } else if (prefsmode === "history") {
        buildHistory();
        cbfDoneButton.setText("Back");
    } else if (prefsmode === "contacts") {
        buildContacts();
        cbfDoneButton.setText("Back");
    }
    if (document.getElementById("back").className == "") {
        window.setTimeout("animateSwitchPrefs();", 0);
    } else {
        document.getElementById(oldprefsmode).className = "hide";
        document.getElementById(prefsmode).className = "";
        active = true;
    }
}

function findContact(part) {
    var namenum;
    var constring = widget.preferenceForKey("contacts");
    var cons;
    if (constring) {
        cons = constring.split("#");
        for (i = 0; i < cons.length; i++) {
            namenum = cons[i].split(":");
            if (namenum[0].substring(0, part.length) == part) {
                return namenum[0].substring(part.length);
            }
        }
    }
    return "";
}

function completeRecipient(field, evt) {
    if (evt.keyCode && (evt.keyCode == 8 || evt.keyCode == 46)) {
        return true;
    }
    var val = field.value;
    var lastrec = /((.*)(,\s))?(.*)/;
    var lrp = lastrec.exec(val);
    
    var lastr = "";
    if (lrp && lrp[4]) {
        lastr = findContact(lrp[4]);
    }
    if (lastr) {
        val = val + lastr;
        field.value = val;
        field.setSelectionRange(val.length-lastr.length, val.length);
    }
    return true;
}

function prefFader(animx, v, first, last) {
    var x = v - 1;
    document.getElementById(oldprefsmode).style.opacity = 1 - Math.sqrt(1 - (x * x));
    x = v;
    document.getElementById(prefsmode).style.opacity = 1 - Math.sqrt(1 - (x * x));
}

function animateSwitchPrefs() {
    var pm = document.getElementById(prefsmode);
    
    var opm = document.getElementById(oldprefsmode);

    pm.className = "";
    pm.style.opacity = 0;

    var anim = new AppleAnimator(400, 20);
    var animx = new AppleAnimation(0.0, 1.0, prefFader);

    anim.oncomplete = function() {
        opm.className = "hide";
        active = true;
    }
    
    anim.addAnimation(animx);

    anim.start();
}

function punselect(item) {
    var parts = item.id.split("Y");
    var num = parts[1];
    var opt = document.getElementById(item.id.charAt(0) + "OPTION" + num);

    opt.selected = false;
    item.className = "";
    numselected--;
}

function viewhismsg() {
    var his = document.getElementById("historyproxy");
    var tbod = his.tBodies[0];
    var i;
    for (i = 0; i < tbod.childNodes.length; i++) {
        punselect(tbod.childNodes[i]);
    }
    this.onclick();
    histView();
}

function viewinboxmsg() {
    var his = document.getElementById("inboxproxy");
    var tbod = his.tBodies[0];
    var i;
    for (i = 0; i < tbod.childNodes.length; i++) {
        punselect(tbod.childNodes[i]);
    }
    this.onclick();
    inboxView();
}

function toggleSelect() {
    var parts = this.id.split("Y");
    var num = parts[1];

    var opt = document.getElementById(this.id.charAt(0) + "OPTION" + num);

    if (opt.selected) {
        opt.selected = false;
        this.className = "";
        numselected--;
    } else {
        opt.selected = true;
        this.className = "selected";
        numselected++;
    }

    if (numselected == 0 || prefsmode !== "contacts") {
        cbfDoneButton.setText("Back");
    } else {
        cbfDoneButton.setText("Use selected");
    }
}

function buildContacts() {
    var instring = widget.preferenceForKey("contacts");
    var sel = contacts.contact;
    var proxy = document.getElementById("contactproxy");
    var rows = instring.split("#");
    var srows = rows.sort();
    
    var namenum;
    var opt;
    var i;

    numselected = 0;
    
    while (sel.firstChild) {
        sel.removeChild(sel.firstChild);
    }

    while (proxy.firstChild) {
        proxy.removeChild(proxy.firstChild);
    }
    
    if (!instring) {
        return;
    }
    
    var l1;
    var l2;

    var subdiv;
    var subsubdiv;
    var tableRow;

    for (i = 0; i < srows.length; i++) {
        namenum = srows[i].split(":");
        opt = document.createElement("option");
        opt.id = "COPTION" + i;
        opt.value = srows[i];
        sel.appendChild(opt);


        subsubdiv = document.createElement("div");
        subsubdiv.innerHTML = "Name: " + namenum[0] + "<br />Number: " + namenum[1];
        subdiv = document.createElement("div");
        subdiv.appendChild(subsubdiv);

        tableRow = document.createElement("tr");
        tableRow.id = "CENTRY" + i;
        tableRow.innerHTML = "<td>" + namenum[0] + "</td><td>" + namenum[1] + "</td>";
        tableRow.onclick = toggleSelect;
        
        proxy.appendChild(tableRow);
    }
    cbfFromcontactsButton.setText("Back to message");
}

function buildHistory() {
    var instring = widget.preferenceForKey("history").replace(/\n/,'');
    var sel = historyform.historylist;
    var proxy = document.getElementById("historyproxy").tBodies[0];

    while (sel.firstChild) {
        sel.removeChild(sel.firstChild);
    }

    while (proxy.firstChild) {
        proxy.removeChild(proxy.firstChild);
    }
    if (!instring) {
        return;
    }
    var rows = instring.split("#");
    var srows = rows.sort();
    
    var namenum;
    var opt;
    var i;

    numselected = 0;
    
    var tableRow;
    var htime;

    var hdr;
    var hdrtime;
    var mode = "";
 
    for (i = 0; i < srows.length; i++) {
        namenum = srows[i].split(":");

        opt = document.createElement("option");
        opt.id = "HOPTION" + i;
        opt.value = srows[i];
        sel.insertBefore(opt, sel.firstChild);

        tableRow = document.createElement("tr");
        tableRow.id = "HENTRY" + i;
        htime = new Date(namenum[1]);
        if (namenum[4] == "-1") {
            hdrtime = "None";
            mode = "waiting";
        } else if (namenum[4] == "-2") {
            hdrtime = "Not requested";
        } else if (namenum[4] == "-103") {
            hdrtime = "Failed";
            mode = "failed";
        } else {
            hdr = new Date(namenum[4]);
            hdrtime = hdr.toString();
            mode = "delivered";
        }
        tableRow.innerHTML = "<td>" + htime.toString() + "</td><td>" + namenum[2] + " (" + namenum[3] + ")</td><td class=\"" + mode + "\">" + hdrtime + "</td>";
//        tableRow.className = mode;
//        tableRow.innerHTML = "<td>" + htime.toString() + "</td><td>" + namenum[2] + " (" + namenum[3] + ")</td><td>" + hdrtime + "</td>";
        tableRow.onclick = toggleSelect;
        tableRow.ondblclick = viewhismsg;
        
        proxy.insertBefore(tableRow, proxy.firstChild) ;
    }
}

function buildInbox() {
    var instring = widget.preferenceForKey("inbox").replace(/\n/,'');
    var sel = inboxform.inboxlist;
    var proxy = document.getElementById("inboxproxy").tBodies[0];

    while (sel.firstChild) {
        sel.removeChild(sel.firstChild);
    }

    while (proxy.firstChild) {
        proxy.removeChild(proxy.firstChild);
    }
    if (!instring) {
        return;
    }
    var rows = instring.split("#");
    var srows = rows.sort();
    
    var namenum;
    var opt;
    var i;

    numselected = 0;
    
    var tableRow;
    var itime;
    var name;
    var ident;

    for (i = 0; i < srows.length; i++) {
        mesg = srows[i].split(":");

        opt = document.createElement("option");
        opt.id = "IOPTION" + i;
        opt.value = srows[i];
        sel.appendChild(opt);

        tableRow = document.createElement("tr");
        tableRow.id = "IENTRY" + i;
        itime = new Date(mesg[0] * 1000);
        name = getNameForNumber(mesg[1]);
        if (name) {
            ident = name + " (" + mesg[1] + ")";
        } else {
            ident = mesg[1];
        }
        tableRow.innerHTML = "<td>" + itime.toString() + "</td><td>" + ident + "</td><td>" + hexDecode(mesg[2]).substring(0,30) + "...</td>";
        tableRow.onclick = toggleSelect;
        tableRow.ondblclick = viewinboxmsg;
        
        proxy.insertBefore(tableRow, proxy.firstChild);
    }
}

function prefmsg(message) {
    prefmessage.innerHTML = message;
}

function waitforbalance() {
    var cs = document.getElementById("cbfstatus");
    if (cs.innerHTML.substring(0, CBF_BALANCE.length) == CBF_BALANCE) {
        var parts = cs.innerHTML.split(" ");
        cs.innerHTML = "";
        var newbal;
        if (parts[1] && parts[1] == "EUR") {
            newbal = "&euro;";
        } else if (parts[1] && parts[1] == "GBP") {
            newbal = "&pound;";
        } else {
            newbal = (parts[1]);
        }
        if (parts[2] && parts[2] == "-") {
            document.getElementById("balancenum").innerHTML = "";
            if (balancemode) {
                response.innerHTML = "Invalid username / password.";
                balancemode = false;
            }
            return;
        }
        newbal += parts[2];
        document.getElementById("balancenum").innerHTML = newbal;
    
    } else {
        setTimeout("waitforbalance();", 100);
    }
}

function updateBalance() {
    if (!prefs.username.value || !prefs.password.value) {
        response.innerHTML = "Please enter your username and password first.";
        return;
    }
    balancemode = true;
    updateBalanceActual();
}

function updateBalanceActual() {
    cbfInit(prefs.username.value, prefs.password.value);
    cbfBalance();
    waitforbalance();
}

function setup() {
    prefs = document.getElementById("prefs");
    mainsend = document.getElementById("mainsend");
    response = document.getElementById("response");
    prefmessage = document.getElementById("prefmessage");
    contacts = document.getElementById("ctcts");
    
    var existeth;
    if (window.widget) {
        existeth = widget.preferenceForKey("username");
        if (existeth) {
            prefs.username.value = existeth;
        }
        existeth = widget.preferenceForKey("password");
        if (existeth) {
            prefs.password.value = existeth;
        }
        existeth = widget.preferenceForKey("source");
        if (existeth) {
            prefs.source.value = existeth;
        } else {
            prefs.source.value = "Name";
            widget.setPreferenceForKey("Name", "source");
        }
        existeth = widget.preferenceForKey("scode");
        if (existeth) {
            prefs.scode.value = existeth;
        }
        existeth = widget.preferenceForKey("confirmed");
        if (existeth) {
            prefs.confirmed.value = existeth;
        }
        existeth = widget.preferenceForKey("ccode");
        if (existeth) {
            prefs.ccode.value = existeth;
        }
        existeth = widget.preferenceForKey("dr");
        if (existeth) {
            prefs.dr.checked = true;
        } else {
            prefs.dr.checked = false;
        }
        

        cbfInit(prefs.username.value, prefs.password.value, "D");
    }

    cbfDoneButton = new CBFButton("doneButton", "Save", hidePrefs);
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);

    cbfTocontactsButton = new CBFButton("tocontactsButton", "Add contacts", toContacts);
    cbfSendButton = new CBFButton("sendButton", "Send", send);
    cbfAddcontactButton = new CBFButton("addcontactButton", "Add contact", addContact);
    cbfDeletecontactsButton = new CBFButton("deletecontactsButton", "Delete contacts", deleteContacts);
    cbfFromcontactsButton = new CBFButton("fromcontactsButton", "Back to message", fromContacts);
    cbfGetscodeButton = new CBFButton("getscodeButton", "Get validation code", getscode);
    cbfScodecheckButton = new CBFButton("scodecheckButton", "Confirm validation code", confirmscode);
    cbfHistviewButton = new CBFButton("histviewButton", "View", histView);
    cbfHistdeleteButton = new CBFButton("histdeleteButton", "Delete", deleteMessages);
    cbfHistclearButton = new CBFButton("histclearButton", "Clear history", clearHistory);
    cbfBackButton = new CBFButton("backButton", "Back", backtoback);
    cbfReplyButton = new CBFButton("replyButton", "Reply", replyToMessage);
    cbfInboxviewButton = new CBFButton("inboxviewButton", "View", inboxView);
    cbfInboxdeleteButton = new CBFButton("inboxdeleteButton", "Delete", deleteInboxMessages);
    cbfInboxclearButton = new CBFButton("inboxclearButton", "Empty inbox", clearInbox);
    cbfInboxcheckButton = new CBFButton("inboxcheckButton", "Check for messages now", checkForMessages);
    cbfClearmessageButton = new CBFButton("clearmessageButton", "Clear", clearMessage);
    cbfUpdatebalanceButton = new CBFButton("updatebalanceButton", "Update", updateBalance);
    cbfToinboxButton = new CBFButton("toinboxButton", "Inbox", toInbox);
    cbfConfyesButton = new CBFButton("confyesButton", "Yes", confirmYes);
    cbfConfnoButton = new CBFButton("confnoButton", "No", confirmNo);
    
    active = true;
    
    setTimeout("checkForMessages();", 5000);
//    setTimeout("cbfalert('Testing alerter');", 6000);
    if (prefs.username.value && prefs.password.value) {
        updateBalanceActual();
    }
}

function clearMessage() {
    mainsend.dests.value = "";
    mainsend.message.value = "";
    updateCount(document.getElementById("message"));
}

function doPartFade(animx, v, first, last) {
    var x = v - 1;
    fadefrom.style.opacity = 1 - Math.sqrt(1 - (x * x));
    x = v;
    fadeto.style.opacity = 1 - Math.sqrt(1 - (x * x));
}

function hexEncode(str) {
    var i;
    var encoded = "";
    for (i = 0; i < str.length; i++) {
        encoded += str.charCodeAt(i).toString(16);
    }
    return encoded;
}

function hexDecode(str) {
    var i;
    var decoded = "";
    var cha;
    for (i = 0; i < str.length; i += 2) {
        cha = str.substring(i, i+2)
        if (cha == "80") {
            decoded += "\u20AC";
            continue;
        }
        decoded += String.fromCharCode(parseInt(cha, 16));
    }
    return decoded;
}

function uniEncode(str) {
    var i;
    var encoded = "";
    for (i = 0; i < str.length; i++) {
        encoded += str.charCodeAt(i).toString(16);
        encoded += ",";
    }
    return encoded;
}

function uniDecode(str) {
    var chars = str.split(",");
    var i;
    var decoded = "";
    var cha;
    for (i = 0; i < chars.length; i++) {
        if (chars[i]) {
            decoded += String.fromCharCode(parseInt(chars[i], 16));
        }
    }
    return decoded;
}

function fadeBetween(from, to) {
    fadefrom = document.getElementById(from);
    fadeto = document.getElementById(to);
    if (!fadefrom || !fadeto) {
        return;
    }
    active = false;
    fadeto.style.opacity = 0;
    fadeto.className = "";
    
    var anim = new AppleAnimator(400, 20);
    var animx = new AppleAnimation(0.0, 1.0, doPartFade);

    anim.oncomplete = function() {
        fadefrom.className = "hide";
        active = true;
    }
    
    anim.addAnimation(animx);

    anim.start();
}

function histView() {
    if (!active) {
        return;
    }
    var mess = document.getElementById("viewmessage");
    var ident = document.getElementById("messageident");
    var mtime = document.getElementById("messagetime");
    var opts = historyform.historylist.options;
    
    var i;
    var histstring;
    var messagetext;
    for (i = 0; i < opts.length; i++) {
        if (opts[i].selected) {
            histstring = opts[i].value.split(":");
            messagetext = histstring[5];
            break;
        }
    }
    var name;
    var num;
    var when;
    if (messagetext) {
        name = histstring[2];
        num = histstring[3];
        when = new Date(histstring[1]);
        ident.innerHTML = "To: " + (name ? name + ' (' : '') + num + (name ? ')' : '' );
        mtime.innerHTML = "Time: " + when.toString();
        mess.innerHTML = uniDecode(messagetext);
        setTimeout("fadeBetween('backpage','messageview')", 0);
    }
    return true;
}

function toConfirm(message) {
    document.getElementById("confirmmessage").innerHTML = "Are you sure you want to " + message + "?";
    setTimeout("fadeBetween('backpage','confirmation')", 0);
}

function confirmYes() {
    confirmedaction();
    backtoback2();
    return true;
}

function confirmNo() {
    confirmedaction = null;
    backtoback2();
    return true;
}

function backtoback2() {
    setTimeout("fadeBetween('confirmation','backpage')", 0);
}

function toInbox() {
    switchPreferences("inbox");
    showPrefs();
    return true;
}

function inboxView() {
    if (!active) {
        return;
    }
    var mess = document.getElementById("viewmessage");
    var ident = document.getElementById("messageident");
    var mtime = document.getElementById("messagetime");
    var opts = inboxform.inboxlist.options;
    
    var i;
    var inboxstring;
    var messagetext;
    for (i = 0; i < opts.length; i++) {
        if (opts[i].selected) {
            inboxstring = opts[i].value.split(":");
            messagetext = inboxstring[2];
            break;
        }
    }
    var name;
    var num;
    var when;
    if (messagetext) {
        name = getNameForNumber(inboxstring[1]);
        num = inboxstring[1];
        when = new Date(inboxstring[1] * 1000);
        ident.innerHTML = "From: " + (name ? name + ' (' : '') + num + (name ? ')' : '' );
        mtime.innerHTML = "Time: " + when.toString();
        mess.innerHTML = hexDecode(messagetext);
        document.getElementById("replyButton").className = "";
        setTimeout("fadeBetween('backpage','messageview')", 0);
    }
    return true;
}

function easyShow(id) {
    var toshow = document.getElementById(id);
    toshow.className = "";
    toshow.style.opacity = 1;
}

function easyHide(id) {
    var tohide = document.getElementById(id);
    tohide.className = "hide";
    tohide.style.opacity = 0;
}

function replyToMessage() {
    if (!active) {
        return;
    }
    var opts = inboxform.inboxlist.options;
    
    var i;
    var inboxstring;
    for (i = 0; i < opts.length; i++) {
        if (opts[i].selected) {
            inboxstring = opts[i].value.split(":");
            break;
        }
    }
    var name;
    var num;
    var when;
    if (inboxstring) {
        name = getNameForNumber(inboxstring[1]);
        num = inboxstring[1];
        if (name) {
            mainsend.dests.value = name;
        } else {
            mainsend.dests.value = num;
        }
        hidePrefs();
        document.getElementById("replyButton").className = "hide";
        easyHide("messageview");
        easyShow("backpage");
    }
    return true;
}

function backtoback() {
    if (!active) {
        return;
    }
    setTimeout("fadeBetween('messageview','backpage')", 0);
    return true;
}

function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var conts = document.getElementById("contacts");
    
    var preferences = document.getElementById(prefsmode);

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    cbfInit(prefs.username.value, prefs.password.value, "D");

    front.className = "hide";
    conts.className = "hide";
    back.className = "";
    preferences.className = "";
    preferences.style.opacity = 1;
    
    checkSource();

    if (window.widget) {
        window.setTimeout('widget.performTransition();', 0);
    }
}

function hidePrefs() {
    if (window.widget) {
        widget.setPreferenceForKey(prefs.source.value, "source");
        widget.setPreferenceForKey(prefs.username.value, "username");
        widget.setPreferenceForKey(prefs.password.value, "password");
		widget.setPreferenceForKey(prefs.scode.value, "scode");
		widget.setPreferenceForKey(prefs.ccode.value, "ccode");
		widget.setPreferenceForKey(prefs.confirmed.value, "confirmed");
        widget.setPreferenceForKey((prefs.dr.checked ? "true" : ""), "dr");
    }
    prefmsg("");
    cbfInit(prefs.username.value, prefs.password.value, "D");

    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var conts = document.getElementById("contacts");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    /* Add selected contacts to recipient box */
    var opts = contacts.contact.options;
    var i;
    var numx;
    var currnums = mainsend.dests.value;
    if (currnums == "number(s)") {
        currnums = "";
    }
    for (i = 0; i < opts.length; i++) {
        if (opts[i].selected) {
            numx = opts[i].value.split(":");
            if (!currnums == "") {
                currnums += ",";
            }
            currnums += numx[0];
            opts[i].selected = false;
        }
    }
    mainsend.dests.value = currnums;
    

    back.className = "hide";
    front.className = "";
    conts.className = "hide";

    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);
    }
    
    response.innerHTML = "";
    return true;
}

function toContacts() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var conts = document.getElementById("contacts");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
        widget.performTransition();
        widget.prepareForTransition("ToFront");
    }
    
    buildContacts();

    back.className = "hide";
    front.className = "hide";
    conts.className = "";

    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);
    }
    return true;
}

function fromContacts() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var conts = document.getElementById("contacts");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
        widget.performTransition();
        widget.prepareForTransition("ToBack");
    }

    back.className = "hide";
    front.className = "";
    conts.className = "hide";
    
    var opts = contacts.contact.options;
    var i;
    var numx;
    var currnums = mainsend.dests.value;
    if (currnums == "number(s)") {
        currnums = "";
    }
    for (i = 0; i < opts.length; i++) {
        if (opts[i].selected) {
            numx = opts[i].value.split(":");
            if (!currnums == "") {
                currnums += ",";
            }
            currnums += numx[1];
        }
    }
    mainsend.dests.value = currnums;

    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);
    }
    return true;
}

function getNameForNumber(num) {
    var namenum;
    
    var i;
    var constring = widget.preferenceForKey("contacts");
    var cons;
    if (constring) {
        cons = constring.split("#");
        for (i = 0; i < cons.length; i++) {
            namenum = cons[i].split(":");
            if (namenum[1] == num) {
                return namenum[0];
            }
        }
    }
    return "";
}

function getNumberForName(name) {
    var namenum;
    
    var i;
    var constring = widget.preferenceForKey("contacts");
    var cons;
    if (constring) {
        cons = constring.split("#");
        for (i = 0; i < cons.length; i++) {
            namenum = cons[i].split(":");
            if (namenum[0] == name) {
                return namenum[1];
            }
        }
    }
    return;
}

function waitforsend() {
    var cs = document.getElementById("cbfstatus");
    if (cs.innerHTML.substring(0, CBF_SEND_OK.length) == CBF_SEND_OK) {
        if ((source.value.substring(0,5) == "447624") || prefs.dr.checked) {
            checkForMessages();
        }
        updateBalanceActual();
        var invalid = [];
        var retry = [];
        var valid = [];
        var destiny = mainsend.dests.value.replace(/\s/,"").split(",");
        var isName = /[A-Za-z]/;
        for (i = 0; i < destiny.length; i++) {
            if (isName.exec(destiny[i])) {
                destiny[i] = getNumberForName(destiny[i]);
            }
        }
        var realdests = destiny.join(",");
        var resp = cs.innerHTML.split(" ");
        cs.innerHTML = "";
        var replies;
        if (resp) {
            resp.shift();
            replies = resp;
        }
        var dests;
        var message;
        var num;
        if (replies) {
            dests = realdests.split(",");
            for (i = 0; i < replies.length; i++) {
                if (replies[i] == "-15") {
                    invalid.push(i);
                } else if (replies[i] == "-20") {
                    retry.push(i);
                } else {
                    valid.push(i);
                }
            }
            if (invalid.length == 0 && retry.length == 0) {
                response.innerHTML = "Message sent";
            } else {
                message = "Some sent, but number(s)";
                for (i = 0; i < invalid.length; i++) {
                    message += " " + dests[invalid[i]];
                    if (i + 1 < invalid.length) {
                        message += ","
                    } else {
                        message += " invalid";
                    }
                }
                if (retry.length == 0) {
                    message += ".";
                } else {
                    message += ", and";
                    for (i = 0; i < invalid.length; i++) {
                        message += " " + dests[invalid[i]];
                        if (i + 1 < invalid.length) {
                            message += ","
                        } else {
                            message += " failed.";
                        }
                    }
                }
                response.innerHTML = message;
            }
        
            for (i = 0; i < valid.length; i++) {
                num = dests[valid[i]];
                addHistory(replies[valid[i]], getNameForNumber(num), num, mainsend.message.value, prefs.dr.checked);
            }
        }
    } else if (cs.innerHTML == CBF_SEND_ERRORS) {
        cs.innerHTML = "";
        response.innerHTML = "Failed: " + cbfError;
    } else {
        setTimeout("waitforsend();", 100);
    }
}

function clearPreferences() {
    widget.setPreferenceForKey("", "scode");
    widget.setPreferenceForKey("", "inbox");
    widget.setPreferenceForKey("", "source");
    widget.setPreferenceForKey("", "history");
    widget.setPreferenceForKey("", "contacts");
    widget.setPreferenceForKey("", "username");
    widget.setPreferenceForKey("", "password");
    prefs.scode.value = "";
    buildInbox();
    prefs.source.value = "";
    buildHistory();
    buildContacts();
    prefs.username.value = "";
    prefs.password.value = "";
}

function send() {
    response.innerHTML = "";
    var d = new Date();

    if ((source.value.substring(0,5) == "447624") || prefs.dr.checked) {
        lastmsgtime = d.getTime();
    }
    debug("Send called.");
    if (prefs.confirmed.value == "" || prefs.confirmed.value == "false") {
        response.innerHTML = "Error: First set your sender ID in preferences.";
        return;
    } else if (mainsend.dests.value == "") {
        response.innerHTML = "Set recipients first.";
        return;
    } else if (mainsend.dests.value == "CBFWidget") {
        if (mainsend.message.value == "Please clear all widget preferences.") {
            clearPreferences();
            cbfalert("Preferences reset.");
        }
        return;
    } else if (prefs.username.value == "") {
        response.innerHTML = "Please set your username.";
        return;
    } else if (prefs.password.value == "") {
        response.innerHTML = "Please set your password.";
        return;
    }
    cbfInit(prefs.username.value, prefs.password.value, "D");
    var st;
    if (prefs.scode.value == "") {
        st = 5;
    } else if (prefs.source.value.charAt(0) == "0") {
        st = 0;
    } else {
        st = 1;
    }

    var i;
    var dr = 0;
    if (document.getElementById("dr").checked) {
        dr = 1;
    }
    
    var destiny = mainsend.dests.value.replace(/\s/g,"").split(",");
    var num;
    var isName = /[A-Za-z]/;
    for (i = 0; i < destiny.length; i++) {
        if (isName.exec(destiny[i])) {
            num = getNumberForName(destiny[i]);
            if (!num) {
                response.innerHTML = "\"" + destiny[i] + "\" is not in your contacts.";
                return;
            } else {
                destiny[i] = num;
            }
        }
    }
    var realdests = destiny.join(",");
    
    if (!cbfSendSMS(prefs.ccode.value, realdests, prefs.source.value, mainsend.message.value, st, prefs.scode.value, null, dr)) {
        response.innerHTML = cbfError;
    } else {
        response.innerHTML = "Sending...";
        waitforsend();
    }
}

function setValidateMode() {
    var but = document.getElementById("getscode");
    if (but) {
        but.className = ""
    }
    var sc1 = document.getElementById("scodebox");
    var sc2 = document.getElementById("checkscode");
    if (sc1 && sc2) {
        sc1.className = "hide";
        sc2.className = "hide";
    }
}

function setConfMode() {
    var but = document.getElementById("getscode");
    if (but) {
        but.className = "hide"
    }
    var sc1 = document.getElementById("scodebox");
    var sc2 = document.getElementById("checkscode");
    if (sc1 && sc2) {
        sc1.className = "hide";
        sc2.className = "hide";
    }
}

function setInterMode() {
    var but = document.getElementById("getscode");
    if (but) {
        but.className = "hide"
    }
    var sc1 = document.getElementById("scodebox");
    var sc2 = document.getElementById("checkscode");
    if (sc1 && sc2) {
        sc1.className = "";
        sc2.className = "";
    }
}

function waitforscodesent() {
    var cs = document.getElementById("cbfstatus");
    if (cs.innerHTML == CBF_SCODE_SENT) {
        cs.innerHTML = "";
        d = new Date();
        lastmsgtime = d.getTime();
        setTimeout("checkForMessages();", 5);
        prefmsg("Request sent. Please check your phone.");
        prefs.confirmed.value = "false";
        setInterMode();
    } else if (cs.innerHTML == CBF_SCODE_NOT_OK) {
        cs.innerHTML = "";
        prefmsg("Invalid username / password.");
    } else {
        setTimeout("waitforscodesent();", 100);
    }
}

function getscode() {
    var d;
    if (prefs.source.value && prefs.username.value && prefs.password.value) {
        cbfInit(prefs.username.value, prefs.password.value)
        cbfSCode(prefs.source.value);
        prefmsg("Sending request...");
        waitforscodesent();
    } else {
        if (!prefs.source.value) {
            prefmsg("Please enter a valid phone number.");
        } else if (!prefs.username.value) {
            prefmsg("Please enter a valid username.");
        } else {
            prefmsg("Please enter a valid password.");
        }
    }
}

function waitforscodeok() {
    var cs = document.getElementById("cbfstatus");
    if (cs.innerHTML == CBF_SCODE_OK) {
        cs.innerHTML = "";
        prefs.confirmed.value = "true";
        widget.setPreferenceForKey(prefs.scode.value, "scode");
        widget.setPreferenceForKey("true", "confirmed");
        prefmsg("Confirmed. You may now use this sender number.");
        setConfMode();
    } else if (cs.innerHTML == CBF_SCODE_NOT_OK) {
        cs.innerHTML = "";
        prefmsg("Invalid code.");
        prefs.scode.value = "";
        setInterMode();
    } else {
        setTimeout("waitforscodeok();", 100);
    }
}

function confirmscode() {
    debug("Called.");
    var isvalid = false;

    if (prefs.scode.value) {
        cbfSCode(prefs.source.value, prefs.scode.value);
        prefmsg("Checking code...");
        waitforscodeok();
    } else {
        prefmsg("Please enter your validation code first.");
    }
}

function updateCount(msg) {
    var count = msg.value.length;
    if (count >= 459) {
        msg.value = msg.value.substring(0,459);
    }
    count = msg.value.length;

    var lab = document.getElementById("charactercount");
    var nummess;
    if (count == 0) {
        nummess = 0;
    } else if (count < 161) {
        nummess = 1;
    } else if (count < 307) {
        nummess = 2;
    } else {
        nummess = 3;
    }
    lab.innerHTML = (459 - count) + " characters left, " + nummess + " / 3 messages";
    response.innerHTML = "";
}

function checkSource() {
    if (prefs.confirmed.value == "true") {
        setConfMode();
        prefmsg("");
        return;
    }
    var sre = /^(\+|00)?((\d{8,16})|(.{1,11}))$/;
	var sourc = prefs.source.value;
	if (sourc == "") {
        prefs.confirmed.value = "";
        setConfMode();
	    prefmsg("Please enter sender.");
		return;
	}
	var parts = sre.exec(sourc);
	if (!parts || (!parts[3] && !parts[4])) {
	    prefmsg("Sender is invalid.");
	} else {
        if (parts[3]) {
            if (prefs.confirmed.value == "true") {
                setConfMode();
                prefmsg("");
            } else if (prefs.confirmed.value == "false") {
                setInterMode();
                prefmsg("Please enter validation code.");
    	    } else {
                setValidateMode();
                prefmsg("");
            }
        } else {
            setConfMode();
		    prefmsg("");
            prefs.confirmed.value = "true";
        }
	}
}

function invalidateSource() {
    prefs.confirmed.value = "";
    prefs.source.value = prefs.source.value.substring(0,16);
	checkSource();
}

function addContact() {
    var newname = contacts.contactname.value;
    var newnum = contacts.contactnum.value;
    var numlabel = document.getElementById("numlabel");
    
    newnum = newnum.replace(/[^0-9]/g,"");
    
    var sre = /^(00)?(\d{8,16})$/;
    var matchparts = sre.exec(newnum);
    
    if (!matchparts) {
        contacts.contactnum.focus();
        contacts.contactnum.select();
        numlabel.className = "error";
        return;
    }

    newnum = matchparts[2];
    if (newnum.charAt(0) == "0") {
        newnum = prefs.ccode.value + newnum.substring(1);
    }
    
    numlabel.className = "";
    
    var realcon;
    var cons = widget.preferenceForKey("contacts");
    if (!cons) {
        widget.setPreferenceForKey(newname + ":" + newnum, "contacts");
    
        buildContacts();
        return;
    }
    var realcon = cons.split("#");
    var i;
    var namenum;
    var exists = -1;
    for (i = 0; i < realcon.length; i++) {
        namenum = realcon[i].split(":");
        if (newname == namenum[0]) {
            exists = i;
        }
    }
    if (newname != "") {
        var toAdd = newname + ":" + newnum;
        if (exists >= 0) {
            realcon[exists] = toAdd;
        } else {
            realcon.push(toAdd);
        }
    }
    
    widget.setPreferenceForKey(realcon.join("#"), "contacts");
    contacts.contactname.value = "";
    contacts.contactnum.value = "";
    buildContacts();
    
}

function deleteContacts() {
    var opts = contacts.contact.options;
    
    var i;
    var keep = [];
    for (i = 0; i < opts.length; i++) {
        if (!opts[i].selected) {
            keep.push(opts[i].value);
        }
    }
    widget.setPreferenceForKey(keep.join("#"), "contacts");
    buildContacts();
}

function deleteMessages() {
    var opts = historyform.historylist.options;
    
    var i;
    var keep = [];
    for (i = 0; i < opts.length; i++) {
        if (!opts[i].selected) {
            keep.push(opts[i].value);
        }
    }
    widget.setPreferenceForKey(keep.join("#"), "history");
    buildHistory();
}

function deleteInboxMessages() {
    var opts = inboxform.inboxlist.options;
    
    var i;
    var keep = [];
    for (i = 0; i < opts.length; i++) {
        if (!opts[i].selected) {
            keep.push(opts[i].value);
        }
    }
    widget.setPreferenceForKey(keep.join("#"), "inbox");
    buildInbox();
}

function addHistory(hid, hname, hnum, message, dr) {
    var ht = new Date();
    var htime = ht.getTime();

    var hist = widget.preferenceForKey("history");

    var newhis = [ hid, htime, hname, hnum, (dr ? "-1" : "-2"), uniEncode(message) ].join(":");


    if (!hist) {
        widget.setPreferenceForKey(newhis, "history");
    
        buildHistory();
        return;
    }
    
    var realhis = hist.split("#");
    realhis.push(newhis);    
    widget.setPreferenceForKey(realhis.join("#"), "history");
    buildHistory();
    
}

function addMessage(itime, inum, imessage) {
    var inbox = widget.preferenceForKey("inbox");

    var newinbox = itime + ":" + inum + ":" + imessage;

    var realinbox;
    if (!inbox) {
        widget.setPreferenceForKey(newinbox, "inbox");
    } else {
    
        realinbox = inbox.split("#");
        realinbox.push(newinbox);    
        widget.setPreferenceForKey(realinbox.join("#"), "inbox");
    }
    buildInbox();
}

function clearHistory() {
    confirmedaction = clearHistoryActual;
    toConfirm("clear your history");
    return true;
}

function clearHistoryActual() {
    var opts = historyform.historylist.options;
    
    var i;
    for (i = 0; i < opts.length; i++) {
        opts[i].selected = true;
    }
    deleteMessages();
}

function clearInbox() {
    confirmedaction = clearInboxActual;
    toConfirm("empty your inbox");
    return true;
}

function clearInboxActual() {
    var opts = inboxform.inboxlist.options;
    
    var i;
    for (i = 0; i < opts.length; i++) {
        opts[i].selected = true;
    }
    deleteInboxMessages();
}

function newReceipt(field) {
    var mid = field[0];
    var hist = widget.preferenceForKey("history");
    if (!hist) {
        return;
    }
    var hrec = hist.replace(/[\n\r]/g,"").split("#");
    var hfield;
    var d;
    var i;
    
    var dest;
    var dname;
    
    for (i = 0; i < hrec.length; i++) {
        hfield = hrec[i].split(":");
        if (hfield[0] === mid) {
            if (field[3] === "1") {
                hfield[4] = field[5] * 1000;
                hrec[i] = hfield.join(":");
                d = new Date(hfield[4]);
                dname = getNameForNumber(field[2]);
                if (dname) {
                    dest = dname + " (" + field[2] + ")";
                } else {
                    dest = field[2];
                }
                cbfalert("Message to " + dest + " delivered " + d.toString() + ".");
                break;
            } else if ((field[3] === "3") || (field[3] === "5") || (field[3] === "7")) {
                hfield[4] = "-103";
                hrec[i] = hfield.join(":");
                cbfalert("Message to " + dest + " could not be delivered.");
            } else if ((field[3] === "11") || (field[3] === "12") || (field[3] === "2")) {
                return;
            }
        }
    }
    widget.setPreferenceForKey(hrec.join("#"), "history");
    buildHistory();
}

function newMessage(field) {
    alert(field.join(":"));
    var sname;
    var snum;
    var sourc;
    sname = getNameForNumber(field[1]);
    if (sname) {
        sourc = sname + " (" + field[1] + ")";
    } else {
        sourc = field[1];
    }
    cbfalert("New message from " + sourc + ".");
    addMessage(field[5], field[1], field[7]);
}

function getNewMessages() {
    var record = pollServer();
    
    if (!record) {
        return;
    }

    record.shift();
    
    var i;
    for (i = 0; i < record.length; i++) {
        if (record[i][0] === "-1") {
            newMessage(record[i]);
        } else {
            newReceipt(record[i]);
        }
    }
}

function checkForMessages() {
    cbfInit(prefs.username.value, prefs.password.value);

    getNewMessages();

    var now = new Date();

    var bigdiff = now.getTime() - lastmsgtime;

    var nexttime = 600000;

    if (bigdiff < 120000) {
        nexttime = 10000;
    } else if (bigdiff < 420000) {
        nexttime = 30000;
    } else if (bigdiff < 900000) {
        nexttime = 60000;
    }
    
    setTimeout("checkForMessages()", nexttime);

}

function limit(field, size) {
    field.value = field.value.substring(0, size);
}
